/*++
    Copyright (C) 2009  Matthieu Suiche http://www.msuiche.net

Environment:

    - User mode

Revision History:

    - Matthieu Suiche

--*/

#include "SystemLowPriorityInformation.h"

int main(int argc, char **argv)
{
LOW_PRIORITY_INFORMATION LowPriorityInfo;

OSVERSIONINFO VerInfo;

ULONG NtStatus;

ULONG ReturnedLength;

    wprintf(L"\n"
            L"  Demystifying new Win7 classes (SystemLowPriorityInformation)\n"
            L"  Copyright (c) 2007 - 2009, Matthieu Suiche <http://www.msuiche.net>\n"
            L"  Copyright (c) 2009, MoonSols <http://www.moonsols.com>\n"
            L"\n");

    ZeroMemory(&VerInfo, sizeof(OSVERSIONINFO));
    VerInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

    GetVersionEx(&VerInfo);

    if (!((VerInfo.dwMajorVersion >= 6) && (VerInfo.dwMinorVersion >= 1)))
    {
        wprintf(L"The system does not meet the requirements. Windows 7 or later is required.\n");
    }

    *(FARPROC *)&NtQuerySystemInformationEx = GetProcAddress(LoadLibraryA("ntdll.dll"), "NtQuerySystemInformationEx");

    if (NtQuerySystemInformationEx == NULL)
    {
        wprintf(L"Cannot retrieve NtQuerySystemInformationEx address from ntdll.dll\n");
        return FALSE;
    }

    *(FARPROC *)&NtQuerySystemInformation = GetProcAddress(LoadLibraryA("ntdll.dll"), "NtQuerySystemInformation");

    if (NtQuerySystemInformation == NULL)
    {
        wprintf(L"Cannot retrieve NtQuerySystemInformation address from ntdll.dll\n");
        return FALSE;
    }

    //
    // SystemLowPriorityInformation
    //
    memset(&LowPriorityInfo, 0, sizeof(LOW_PRIORITY_INFORMATION));
    NtStatus = NtQuerySystemInformation(SystemLowPriorityInformation,
                                        &LowPriorityInfo,
                                        sizeof(LOW_PRIORITY_INFORMATION),
                                        &ReturnedLength);

    if (NtStatus != STATUS_SUCCESS)
    {
        wprintf(L"NtQuerySystemInformationEx(SystemLowPriorityInformation) = 0x%08X\n",
                NtStatus);
        return FALSE;
    }

    if (ReturnedLength != sizeof(LOW_PRIORITY_INFORMATION))
    {
        wprintf(L"Returned len (0x%08X) is different from 0x%08X\n",
                sizeof(LOW_PRIORITY_INFORMATION));
        return FALSE;
    }

    wprintf(L"\nSystemLowPriorityInformation:\n");
    wprintf(L"  IoLowPriorityReadOperationCount:        0x%08X (%d)\n"
            L"  IoLowPriorityWriteOperationCount:       0x%08X (%d)\n"
            L"  IoKernelIssuedIoBoostedCount:           0x%08X (%d)\n"
            L"  IoPagingReadLowPriorityCount:           0x%08X (%d)\n"
            L"  IoPagingReadLowPriorityBumpedCount:     0x%08X (%d)\n"
            L"  IoPagingWriteLowPriorityCount:          0x%08X (%d)\n"
            L"  IoPagingWriteLowPriorityBumpedCount:    0x%08X (%d)\n"
            L"  IoBoostedThreadedIrpCount:              0x%08X (%d)\n"
            L"  IoBoostedPagingIrpCount:                0x%08X (%d)\n",
            LowPriorityInfo.IoLowPriorityReadOperationCount,
            LowPriorityInfo.IoLowPriorityReadOperationCount,
            LowPriorityInfo.IoLowPriorityWriteOperationCount,
            LowPriorityInfo.IoLowPriorityWriteOperationCount,
            LowPriorityInfo.IoKernelIssuedIoBoostedCount,
            LowPriorityInfo.IoKernelIssuedIoBoostedCount,
            LowPriorityInfo.IoPagingReadLowPriorityCount,
            LowPriorityInfo.IoPagingReadLowPriorityCount,
            LowPriorityInfo.IoPagingReadLowPriorityBumpedCount,
            LowPriorityInfo.IoPagingReadLowPriorityBumpedCount,
            LowPriorityInfo.IoPagingWriteLowPriorityCount,
            LowPriorityInfo.IoPagingWriteLowPriorityCount,
            LowPriorityInfo.IoPagingWriteLowPriorityBumpedCount,
            LowPriorityInfo.IoPagingWriteLowPriorityBumpedCount,
            LowPriorityInfo.IoBoostedThreadedIrpCount,
            LowPriorityInfo.IoBoostedThreadedIrpCount,
            LowPriorityInfo.IoBoostedPagingIrpCount,
            LowPriorityInfo.IoBoostedPagingIrpCount);

    return TRUE;
}