/*++
    Copyright (C) 2009  Matthieu Suiche http://www.msuiche.net

Environment:

    - User mode

Revision History:

    - Matthieu Suiche

--*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#define STATUS_SUCCESS 0

typedef enum _SYSTEM_INFORMATION_CLASS
{
    SystemLogicalProcessorAndGroupInformation = 107,
    SystemLogicalGroupInformation = 108,
    SystemStoreInformation = 109,
    SystemVhdBootInformation = 112,
    SystemCpuQuotaInformation = 113,
    SystemHardwareCountersInformation = 115,
    SystemLowPriorityInformation = 116,
    SystemTpmBootEntropyInformation = 117,
    SystemVerifierInformation = 118,
    SystemNumaNodesInformation = 121,
    MaxSystemInfoClass = 122
} SYSTEM_INFORMATION_CLASS, *PSYSTEM_INFORMATION_CLASS;

//
// SystemLowPriorityInformation
//
typedef struct _LOW_PRIORITY_INFORMATION
{
    ULONG IoLowPriorityReadOperationCount;
    ULONG IoLowPriorityWriteOperationCount;
    ULONG IoKernelIssuedIoBoostedCount;
    ULONG IoPagingReadLowPriorityCount;
    ULONG IoPagingReadLowPriorityBumpedCount;
    ULONG IoPagingWriteLowPriorityCount;
    ULONG IoPagingWriteLowPriorityBumpedCount;
    ULONG IoBoostedThreadedIrpCount;
    ULONG IoBoostedPagingIrpCount;
} LOW_PRIORITY_INFORMATION, *PLOW_PRIORITY_INFORMATION;

//
// Functions
//
NTSTATUS (WINAPI *NtQuerySystemInformationEx)(SYSTEM_INFORMATION_CLASS SystemInformationClass,
                                              PULONG QueryType,
                                              ULONG Alignment,
                                              PVOID SystemInformation,
                                              ULONG SystemInformationLength,
                                              PULONG ReturnLength);


NTSTATUS (WINAPI *NtQuerySystemInformation)(SYSTEM_INFORMATION_CLASS SystemInformationClass,
                                            PVOID SystemInformation,
                                            ULONG SystemInformationLength,
                                            PULONG ReturnLength);
